// $Id: prefdebugger.h,v 1.1 1999/05/29 17:08:47 jsixt Exp $

// Copyright by Johannes Sixt
// This file is under GPL, the GNU General Public Licence

#ifndef PREFDEBUGGER_H
#define PREFDEBUGGER_H

#include <qlayout.h>
#include <qlineedit.h>
#include <qlabel.h>

class PrefDebugger : public QWidget
{
public:
    PrefDebugger(QWidget* parent);

    QGridLayout m_grid;

    // --- the hint about defaults
protected:
    QLabel m_defaultHint;

    // --- the debugger command
protected:
    QLabel m_debuggerCCppLabel;
    QLineEdit m_debuggerCCpp;
public:
    QString debuggerCmd() const { return m_debuggerCCpp.text(); }
    void setDebuggerCmd(const QString& cmd) { m_debuggerCCpp.setText(cmd); }

    // --- the output terminal
protected:
    QLabel m_terminalHint;
    QLabel m_terminalLabel;
    QLineEdit m_terminal;
public:
    QString terminal() const { return m_terminal.text(); }
    void setTerminal(const QString& t) { m_terminal.setText(t); }
};

#endif // PREFDEBUGGER_H
